searchData={"items":[{"type":"module","title":"Dicom.BinaryFormat","doc":"This module implements the DICOM binary data format according to\n[PS 3.5](https://dicom.nema.org/medical/dicom/current/output/chtml/part05/PS3.5.html).","ref":"Dicom.BinaryFormat.html"},{"type":"function","title":"Dicom.BinaryFormat.from_binary/2","doc":"","ref":"Dicom.BinaryFormat.html#from_binary/2"},{"type":"function","title":"Dicom.BinaryFormat.from_binary_until/3","doc":"","ref":"Dicom.BinaryFormat.html#from_binary_until/3"},{"type":"function","title":"Dicom.BinaryFormat.from_file/1","doc":"","ref":"Dicom.BinaryFormat.html#from_file/1"},{"type":"function","title":"Dicom.BinaryFormat.from_file!/1","doc":"","ref":"Dicom.BinaryFormat.html#from_file!/1"},{"type":"function","title":"Dicom.BinaryFormat.read_next_data_element/2","doc":"","ref":"Dicom.BinaryFormat.html#read_next_data_element/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_command_data_set/1","doc":"","ref":"Dicom.BinaryFormat.html#serialize_command_data_set/1"},{"type":"function","title":"Dicom.BinaryFormat.serialize_cs/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_cs/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_data_element/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_data_element/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_lo/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_lo/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_pn/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_pn/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_sh/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_sh/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_u16/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_u16/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_u32/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_u32/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_uid/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize_uid/2"},{"type":"module","title":"Dicom.DataElement","doc":"Implements a DICOM data element.\n\nReferences:\n  * https://dicom.nema.org/dicom/2013/output/chtml/part05/chapter_7.html","ref":"Dicom.DataElement.html"},{"type":"function","title":"Dicom.DataElement.from/2","doc":"","ref":"Dicom.DataElement.html#from/2"},{"type":"function","title":"Dicom.DataElement.from/4","doc":"","ref":"Dicom.DataElement.html#from/4"},{"type":"type","title":"Dicom.DataElement.t/0","doc":"","ref":"Dicom.DataElement.html#t:t/0"},{"type":"function","title":"Dicom.DataElement.tag/1","doc":"","ref":"Dicom.DataElement.html#tag/1"},{"type":"function","title":"Dicom.DataElement.tag/2","doc":"","ref":"Dicom.DataElement.html#tag/2"},{"type":"function","title":"Dicom.DataElement.value/2","doc":"","ref":"Dicom.DataElement.html#value/2"},{"type":"module","title":"Dicom.DataSet","doc":"","ref":"Dicom.DataSet.html"},{"type":"function","title":"Dicom.DataSet.fetch/2","doc":"","ref":"Dicom.DataSet.html#fetch/2"},{"type":"function","title":"Dicom.DataSet.fetch!/2","doc":"","ref":"Dicom.DataSet.html#fetch!/2"},{"type":"function","title":"Dicom.DataSet.from_elements/1","doc":"","ref":"Dicom.DataSet.html#from_elements/1"},{"type":"function","title":"Dicom.DataSet.from_keyword_list/1","doc":"","ref":"Dicom.DataSet.html#from_keyword_list/1"},{"type":"type","title":"Dicom.DataSet.t/0","doc":"","ref":"Dicom.DataSet.html#t:t/0"},{"type":"function","title":"Dicom.DataSet.to_string/1","doc":"","ref":"Dicom.DataSet.html#to_string/1"},{"type":"function","title":"Dicom.DataSet.value_for!/3","doc":"","ref":"Dicom.DataSet.html#value_for!/3"},{"type":"module","title":"Dicom.TagDict","doc":"","ref":"Dicom.TagDict.html"},{"type":"function","title":"Dicom.TagDict.get_by_tag_parts/3","doc":"","ref":"Dicom.TagDict.html#get_by_tag_parts/3"},{"type":"function","title":"Dicom.TagDict.get_tag_parts_by_keyword/1","doc":"","ref":"Dicom.TagDict.html#get_tag_parts_by_keyword/1"},{"type":"module","title":"Dicom.TagDict.Dict","doc":"","ref":"Dicom.TagDict.Dict.html"},{"type":"function","title":"Dicom.TagDict.Dict.by_tag/0","doc":"","ref":"Dicom.TagDict.Dict.html#by_tag/0"},{"type":"module","title":"Dicom.UidRegistry","doc":"","ref":"Dicom.UidRegistry.html"},{"type":"function","title":"Dicom.UidRegistry.get_default_transfer_syntax/0","doc":"","ref":"Dicom.UidRegistry.html#get_default_transfer_syntax/0"},{"type":"function","title":"Dicom.UidRegistry.get_transfer_syntax/1","doc":"","ref":"Dicom.UidRegistry.html#get_transfer_syntax/1"},{"type":"module","title":"DicomNet.Association","doc":"Defines a DICOM association.\n\nA DICOM association represents an established network connection\nbetween two application entities (AEs). The association is the result\nof successfully negotiating user identities, what data will be\nexchanged and how it will be encoded.\n\nSee also:\n  * https://dicom.nema.org/dicom/2013/output/chtml/part07/sect_D.3.html","ref":"DicomNet.Association.html"},{"type":"function","title":"DicomNet.Association.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DicomNet.Association.html#child_spec/1"},{"type":"function","title":"DicomNet.Association.start/1","doc":"","ref":"DicomNet.Association.html#start/1"},{"type":"module","title":"DicomNet.Endpoint","doc":"Defines a DICOM network endpoint.\n\nThe endpoint is the boundary where all DICOM upper layer network connection\nenter the system. For every connection, a `DicomNet.Association` is instantiated.\nIf the assocation is established successfully, received DICOM operations\nare forwarded to registered listeners as messages.\n\nSee also:\n  * https://dicom.nema.org/dicom/2013/output/chtml/part08/chapter_9.htmIO.inspect(command_ds)","ref":"DicomNet.Endpoint.html"},{"type":"function","title":"DicomNet.Endpoint.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DicomNet.Endpoint.html#child_spec/1"},{"type":"function","title":"DicomNet.Endpoint.start_link/1","doc":"","ref":"DicomNet.Endpoint.html#start_link/1"},{"type":"module","title":"DicomNet.Pdu","doc":"This module implements the DICOM upper layer network protocol according to\n[PS 3.8](https://dicom.nema.org/dicom/2013/output/chtml/part08/PS3.8.html).","ref":"DicomNet.Pdu.html"},{"type":"function","title":"DicomNet.Pdu.from_data/1","doc":"","ref":"DicomNet.Pdu.html#from_data/1"},{"type":"function","title":"DicomNet.Pdu.new_associate_accept_response_pdu/1","doc":"","ref":"DicomNet.Pdu.html#new_associate_accept_response_pdu/1"},{"type":"function","title":"DicomNet.Pdu.new_association_reject_response_pdu/2","doc":"","ref":"DicomNet.Pdu.html#new_association_reject_response_pdu/2"},{"type":"function","title":"DicomNet.Pdu.new_association_release_response_pdu/0","doc":"","ref":"DicomNet.Pdu.html#new_association_release_response_pdu/0"},{"type":"function","title":"DicomNet.Pdu.new_data_pdu/3","doc":"","ref":"DicomNet.Pdu.html#new_data_pdu/3"},{"type":"function","title":"DicomNet.Pdu.parse/1","doc":"","ref":"DicomNet.Pdu.html#parse/1"},{"type":"function","title":"DicomNet.Pdu.serialize/1","doc":"","ref":"DicomNet.Pdu.html#serialize/1"},{"type":"task","title":"mix dicom.tagdict.create","doc":"Downloads and parses the tag dictionaries and generates a Elixir module.","ref":"Mix.Tasks.Dicom.Tagdict.Create.html"},{"type":"function","title":"Mix.Tasks.Dicom.Tagdict.Create.run/1","doc":"","ref":"Mix.Tasks.Dicom.Tagdict.Create.html#run/1"},{"type":"extras","title":"Dicom.ex","doc":"# Dicom.ex\n\nDicom.ex is a Elixir library implementing the [DICOM](https://www.dicomstandard.org/)\nstandard for data storage and network transfers.\n\n**Attention:** This project is a personal project to\nlearn Elixir and DICOM internals. It should not be used\nin production and absolutely not in clinical contexts.","ref":"readme.html"},{"type":"extras","title":"Features - Dicom.ex","doc":"* General methods to work with DICOM data sets and elements\n* Read data sets from files encode according to [DICOM Part 3.10](https://dicom.nema.org/medical/dicom/current/output/chtml/part10/chapter_7.html)\n* Supports VRs and tag dictionary as of DICOM version 2024d\n* Receive C-ECHO, C-FIND and C-STORE network requests ([DICOM Part 3.7](https://dicom.nema.org/medical/dicom/current/output/chtml/part07/PS3.7.html))","ref":"readme.html#features"},{"type":"extras","title":"SCP Handlers - Dicom.ex","doc":"At the moment of configuring SCP services, the final developer must define functions called `event_handlers` which will take\ncare of the response to the SCU, based on the data received.  \n\nAt the moment of writing this readme, there are these handlers:  \n\n**association_validator**  \n> Allows/Rejects incomming connections.   \n\n**cfind**  \n> Receives incoming C-FIND requests and returns a Stream containing matches.  \n\n**cstore**  \n> Receives incoming C-STORE requests. The handler have access to the incoming dicom file and must take care of saving to filesystem, database, etc.","ref":"readme.html#scp-handlers"},{"type":"extras","title":"Examples - Dicom.ex","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Dicom parsing and writing - Dicom.ex","doc":"The following examples shows how to parse and access/write data from/to dicom files.","ref":"readme.html#dicom-parsing-and-writing"},{"type":"extras","title":"Create and access DICOM data set - Dicom.ex","doc":"```elixir\nds =\n  Dicom.DataSet.from_keyword_list(\n    SOPInstanceUID: \"1.2.3\",\n    PatientID: \"ABC123\",\n    ImageType: [\"Test1\", \"Test2\", \"Test3\"]\n  )\n\nassert Dicom.DataSet.value_for!(ds, :PatientID) == \"ABC123\"\nassert Dicom.DataSet.value_for!(ds, :ImageType, 2) == \"Test3\"\n```","ref":"readme.html#create-and-access-dicom-data-set"},{"type":"extras","title":"Read DICOM data set from file - Dicom.ex","doc":"```elixir\nds = Dicom.BinaryFormat.from_file!(\"test/test_files/test-ExplicitVRLittleEndian.dcm\")\n```","ref":"readme.html#read-dicom-data-set-from-file"},{"type":"extras","title":"Dicom SCP - Dicom.ex","doc":"The following examples show how to create Dicom SCP services and their handlers.","ref":"readme.html#dicom-scp"},{"type":"extras","title":"Association Validation - Dicom.ex","doc":"This example allows incoming requests pointing to `TEST` AETitle, all other AETitles are rejected.  \n\nTo test an _accepting association_ you could run echoscu (from [dcmtk](https://dicom.offis.de/dcmtk.php.en)) this way:  \n\n```\nechoscu -d -aec TEST 127.0.0.1 4242\n```\n\nTo test an _rejecting association_:  \n\n```\nechoscu -d -aec OTHERAET 127.0.0.1 4242\n```\n\n```elixir\ndefmodule AssociationExample do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\nend\n```","ref":"readme.html#association-validation"},{"type":"extras","title":"C-FIND SCP - Dicom.ex","doc":"Adding up to the association validation example, we'll add a `cfind` handler:  \n\n```elixir\ndefmodule CFindSCP do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        cfind: &get_responses/1,\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\n\n  defp get_responses(dataset) do\n    # Rename tags with atoms\n    fields = Enum.map(dataset, fn {k, v} ->\n          group = v.group_number\n          element = v.element_number\n          values = v.values\n          case {group, element} do\n              {0x0008, 0x0050} -> {:AccessionNumber, values}\n              {0x0010, 0x0010} -> {:PatientName, values}\n              {0x0010, 0x0020} -> {:PatientID, values}\n            _ -> {:Ignore, nil}\n          end\n        end\n    ) \n\n    # sample study list\n    studies = [\n      [\"PatientName\": \"Carmack^John\", PatientID: \"1\", AccessionNumber: \"A001\"],\n      [\"PatientName\": \"Kernighan^Brian\", PatientID: \"2\", AccessionNumber: \"A002\"],\n      [\"PatientName\": \"Torvalds^Linus\", PatientID: \"3\", AccessionNumber: \"A003\"],\n      [\"PatientName\": \"Van Rossum^Guido\", PatientID: \"4\", AccessionNumber: \"A004\"],\n      [\"PatientName\": \"Valim^José\", PatientID: \"5\", AccessionNumber: \"A005\"]\n    ]\n\n    # Return the list excluding those fields not present in fields list.\n    Stream.map(studies, fn study ->\n      Keyword.take(study, Keyword.keys(fields)) \n      |>Dicom.DataSet.from_keyword_list()\n    end) \n  end\n\nend\n```","ref":"readme.html#c-find-scp"},{"type":"extras","title":"C-STORE SCP - Dicom.ex","doc":"This last example includes all the handlers available at this moment, `association_validator`, `cfind` and `cstore`.  \n\n```elixir\ndefmodule SCP do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        cfind: &get_responses/1,\n        cstore: &store_image/1,\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\n\n  defp get_responses(dataset) do\n    # Rename tags with atoms\n    fields = Enum.map(dataset, fn {k, v} ->\n          group = v.group_number\n          element = v.element_number\n          values = v.values\n          case {group, element} do\n              {0x0008, 0x0050} -> {:AccessionNumber, values}\n              {0x0010, 0x0010} -> {:PatientName, values}\n              {0x0010, 0x0020} -> {:PatientID, values}\n            _ -> {:Ignore, nil}\n          end\n        end\n    ) \n\n    # sample study list\n    studies = [\n      [\"PatientName\": \"Carmack^John\", PatientID: \"1\", AccessionNumber: \"A001\"],\n      [\"PatientName\": \"Kernighan^Brian\", PatientID: \"2\", AccessionNumber: \"A002\"],\n      [\"PatientName\": \"Torvalds^Linus\", PatientID: \"3\", AccessionNumber: \"A003\"],\n      [\"PatientName\": \"Van Rossum^Guido\", PatientID: \"4\", AccessionNumber: \"A004\"],\n      [\"PatientName\": \"Valim^José\", PatientID: \"5\", AccessionNumber: \"A005\"]\n    ]\n\n    # Return the list excluding those fields not present in fields list.\n    Stream.map(studies, fn study ->\n      Keyword.take(study, Keyword.keys(fields)) \n      |>Dicom.DataSet.from_keyword_list()\n    end) \n  end\n\n  defp store_image(data) do\n    # just print the incoming dataset\n    IO.inspect(data, label: \"C-STORE\")\n  end\n\nend\n```","ref":"readme.html#c-store-scp"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}